//+------------------------------------------------------------------+
//|                                                 Wilder's DMI.mq4 |
//|                                                  coded by mladen |
//|                                                                  |
//| Directional movement index was developed by Welles Wilder        |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    DMI.Length = 14;
extern double Level      = 20;
extern int    ShowWhat   = 0;
extern int    LinesWidth = 0;

double diu[];
double did[];
double din[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,diu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,did); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,din); SetIndexStyle(2,DRAW_HISTOGRAM);

   return(0);
}
int deinit()
{
   return(0); 
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][9];
#define _DIp        0
#define _DIm        1
#define _ADX        2
#define _ADXR       3
#define _averageDIp 4
#define _averageDIm 5
#define _averageTR  6
#define _trendDIp   7
#define _trendDIm   8

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);


   //
   //
   //
   //
   //
   
   double sf = (DMI.Length-1.0)/DMI.Length;
      for (i=limit, r=Bars-i-1;i>=0;i--,r++)
      {
         double currTR  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         double DeltaHi = High[i] - High[i+1];
	      double DeltaLo = Low[i+1] - Low[i];
         double plusDM  = 0.00;
         double minusDM = 0.00;
         
            if ((DeltaHi > DeltaLo) && (DeltaHi > 0)) plusDM  = DeltaHi;
            if ((DeltaLo > DeltaHi) && (DeltaLo > 0)) minusDM = DeltaLo;      
         
         //
         //
         //
         //
         //
         
            work[r][_averageDIp] = sf*work[r-1][_averageDIp] + plusDM;
            work[r][_averageDIm] = sf*work[r-1][_averageDIm] + minusDM;
            work[r][_averageTR]  = sf*work[r-1][_averageTR]  + currTR;

         //
         //
         //
         //
         //
                  
            work[r][_DIp] = 0.00;                   
            work[r][_DIm] = 0.00;                   
            if (work[r][_averageTR] > 0)
               {              
                  work[r][_DIp] = 100.00 * work[r][_averageDIp]/work[r][_averageTR];
                  work[r][_DIm] = 100.00 * work[r][_averageDIm]/work[r][_averageTR];
               }            
               double DX;
               if((work[r][_DIp] + work[r][_DIm])>0) 
                    DX = 100*MathAbs(work[r][_DIp] - work[r][_DIm])/(work[r][_DIp] + work[r][_DIm]); 
               else DX = 0.00;
               work[r][_ADX]       = sf*work[r-1][_ADX] + DX/DMI.Length; 
               work[r][_ADXR]      = 0.5*(work[r][_ADX] + work[r-DMI.Length][_ADX]);
               work[r][_trendDIp]  = work[r-1][_trendDIp];
               work[r][_trendDIm]  = work[r-1][_trendDIm];
                  if (work[r][_DIp] > Level) work[r][_trendDIp]  =  1;
                  if (work[r][_DIp] < Level) work[r][_trendDIp]  = -1;
                  if (work[r][_DIm] > Level) work[r][_trendDIm]  =  1;
                  if (work[r][_DIm] < Level) work[r][_trendDIm]  = -1;

            diu[i] = EMPTY_VALUE;
            did[i] = EMPTY_VALUE;
            din[i] = EMPTY_VALUE;
            if (ShowWhat==0)
            {
               if (work[r][_trendDIp]== 1) diu[i] = 1;
               if (work[r][_trendDIp]==-1) din[i] = 1;
            }
            else
            {
               if (work[r][_trendDIm]== 1) did[i] = 1;
               if (work[r][_trendDIm]==-1) din[i] = 1;
            }
      }   
   return(0);      
}